// Lexicons/BS/main.js
// Oct 11, 2012. Revised to use jQuery for Ajax and DOM
// Removed 'queryInputChar' function (formerly used as keydown handler)
// Removed standard_input
// Oct 15, 2012.  Modified to work with transcoderjs.
jQuery(document).ready(function(){ 
 theTranscoderField = new TranscoderField('key1',keydown_return);
 win_ls=null;
 VKI.transcoderInit();
 //jQuery('#disp').html("");
});
VKI.transcoderInit = function() {
 VKI.transcoderField = theTranscoderField; // add new attribute to VKI.
 jQuery('#key1').attr('class','keyboardInput'); // needs to precede VKI.load!
 VKI.load();
 transcoderChange(); // install the in/out preferences initialized by VKI.load
 //jQuery('#disp').html("");
 //jQuery('#key1').keydown(keyboard_HandleChar);
 jQuery('#preferenceBtn').click(preferenceBtnFcn);
};


function preferenceBtnFcn(event) {
    showPreferences(); // from keyboard.js
}
function transcoderChange() {
 // Get inval/outval parms from VKI.state via the cookies
 // Note that 'inputType' should be 'phonetic' for the logic to work.
 // At the moment (Oct 15, 2012) the 
 // Note of Oct 16, 2012.  This function is called by
 // (a) the 'ready' function
 // (b) the 'okBtn' function in preferences.htm
  var inputType = readCookie("inputType"); 
  var phoneticInput = readCookie("phoneticInput"); 
  var viewAs = readCookie("viewAs");
 /*
  var inputType = VKI.state.inputType;
  var phoneticInput = VKI.state.phoneticInput;
  var viewAs = VKI.state.viewAs;
 */
  var inval = phoneticInput;
  if (inval == 'it') {inval = 'itrans';}
  var outval = viewAs;
  if ((inputType == 'phonetic') && (outval == 'phonetic')) {
      outval = inval;
  }
  //console.log('transcoderChange: ',inputType,viewAs,inval,outval);
  theTranscoderField.transCoderChange(inval,outval);
}

var requests = new Array();
var requestsActive = new Array();

for (var i=0;i<2;i++) {
try {
  requests[i] = new XMLHttpRequest();
} catch (trymicrosoft) {
  try {
    requests[i] = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (othermicrosoft) {
    try {
      requests[i] = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (failed) {
      requests[i] = null;
    }
  }
}

    if (requests[i] == null){
  alert("Error creating request object!");
    }
 requestsActive[i]=false;
}
//alert("have set requests");
var getlistFlag = false;
function keydown_return() {
 getWord_keyboard(false,false); 
}
 function unused_keyboard_HandleChar(event) {
 // Handler for keydown event
 // presumably, if RETURN key not pressed, next statement passes along
 // the keystroke to some other handler (e.g. that of VKI_devanalysis).
 
 if (event.keyCode != 13) return;
 getWord_keyboard(false,false); 
 // not sure why this stuff here
 if (event.stopPropagation) 
  event.stopPropagation();
 else event.cancelBubble = true;
 if (event.preventDefault) event.preventDefault();
 else event.returnValue = false;
 }

function getWordAlt_keyboard(keyserver) {
 // might be a problem if view differs from server/display
//    document.getElementById("key1").value = keyserver; //chg1
    getWord_keyboard("NO",keyserver,true);  //chg1
}
function getWordlist_keyboard(transflag) {
    var url =   keyboard_parms(false,true,translfag);
//    alert("getWordlist_keyboard: url="+url);
    getWordlist_main(url);
}
function getWordlistUp_keyboard(keyserver) {
    var url =    keyboard_parms(keyserver,true,true) + 
              "&direction=UP";
    getWordlist_main(url);
}
function getWord_hom(keyserver,hom) {
    var url =    keyboard_parms(keyserver,true) + 
              "&hom="+hom;
              //alert(url);
    getWordlist_main(url);
}
function getWordlistDown_keyboard(keyserver) {
    var url =  keyboard_parms(keyserver,true,true) + 
              "&direction=DOWN";
    getWordlist_main(url);
}
function getWord_keyboard(listFlag,keyserver,transflag) {
    var url =  keyboard_parms(keyserver,false,transflag); //chg1
    //console.log('getWord_keyboard: url=',url);
    getWord_main(url);
    if(listFlag == "NO") {
    getlistFlag = false;
    }else {
     getlistFlag = true;
     getWordlist_keyboard(transflag);
    }
}
function show(key){
  var inputType = readCookie("inputType"); 
  var phoneticInput = readCookie("phoneticInput"); 
  var viewAs = readCookie("viewAs");
  var serverOptions = readCookie("serverOptions");
  var url_append="&inputType="+inputType+"&phoneticInput="+phoneticInput+"&serverOptions="+serverOptions+"&viewAs="+viewAs;
  getWord_main("GetWordBS?key="+key+url_append);
  getWordlist_main("GetAlphaBS?key="+key+url_append);

}
function getWord_main(url) {
     //console.log('getWord_main:',url);
    try {
  requests[0].open("GET", url, true);
    requests[0].onreadystatechange = updateDisp;
    requests[0].send(null);
    requestsActive[0]=true;
    jQuery('#disp').html("");
    } catch (failed){
	alert("getWord_main error");
    }
}
function getWordlist_main(url) {
    try{
  requests[1].open("GET", url, true);
    requests[1].onreadystatechange = updateDisplist;
    requests[1].send(null);
    requestsActive[1]=true;
    document.getElementById("displist").innerHTML = '';
    jQuery('#displist').html("");
    }catch (failed){
	alert("getWordlist_main error");
    }
//    '<p>working...</p>' ;
}
function dev2slp (word){
    var output='';var wasCons=false;var output1='';
    var inHex=["05","06","07","08","09","0a","0b","60","0c","0f","10","13","14","02","01","03","3d","4d"];
    var outVH=["a","A","i","I","u","U","f","F","x","e","E","o","O","M","~","H","/",""];
    var matIn=["3e","3f","40","41","42","43","44","62","47","48","4b","4c"];
    var consIn=["15","16","17", "18","19","1a","1b","1c","1d","1e","1f","20","21","22","23","24","25","26","27","28","2a","2b","2c","2d","2e","2f","30","32","35","36","37","38","39"];
    var consOut=["k","K","g","G","N","c","C","j","J","Y","w","W","q","Q","R","t","T","d","D","n","p","P","b","B","m","y","r","l","v","S","z","s","h"];
    word=word.toLowerCase();
    //alert("the word is :"+word);
    if(word.charAt(0)=='%'){
        //alert("OK...inside");
        var totalC=word.length/6;
        //alert("total chars"+totalC);
        for(i=0;i<totalC;i++){
            var char_here=word.substring(6*i,6*(i+1));
            var check=char_here.substring(4);
            for(j=0;j<inHex.length;j++){
		    if(check==inHex[j]){
			if((check=="03")||(check=="01")||(check=="02")||(check=="3d")){
			    if(wasCons){output=output.concat("a"+outVH[j]);}
			    else{output=output.concat(outVH[j]);}
			}
			else{output=output.concat(outVH[j]);}
			wasCons=false;
		    }			
		}
            for(j=0;j<consIn.length;j++){
		   if(check==consIn[j]){
			if(wasCons){output=output.concat("a"+consOut[j]);}
			else{output=output.concat(consOut[j]);}
			if(check!='00'){wasCons=true;}
			else{wasCons=false;}
			if(i==totalC-1){output=output.concat("a");}
		    }
            }
            for(j=0;j<matIn.length;j++){
		    if(check==matIn[j]){output=output.concat(outVH[j+1]);wasCons=false;}
            }
           // alert(output);
            
        }
        
    }
   // alert(output);
    return output;
}

function keyboard_parms(keyserver,listurlFlag,transflag) {  
    var word,inputType,unicodeInput,phoneticInput,viewAs,serverOptions;
    if (keyserver) {
     // 'keyserver' is a word passed as a parameter when the user
     //  clicks on a 'list' word.  In this case the 'viewAs' parameter
     //  has the value of the 'serverOptions' parameter
     word = keyserver;
     inputType = readCookie("inputType");
     unicodeInput = readCookie("unicodeInput");
     phoneticInput = readCookie("phoneticInput");
     viewAs = readCookie("viewAs");
     serverOptions = readCookie("serverOptions");
    }else {
     word = document.getElementById("key1").value;
     inputType = readCookie("inputType");
     unicodeInput = readCookie("unicodeInput");
     phoneticInput = readCookie("phoneticInput");
     viewAs = readCookie("viewAs");
     serverOptions = readCookie("serverOptions");
     // serverOptions = viewAs;  // Nov. 22, 2010
    }
    var url;
    if (listurlFlag) {
	url = "GetAlphaBS"; // alphabetical
    }else { // should be an error condition!
	url = "GetWordBS";
    }
   var ans = 
   url + 
   "?key="+escape(word) + 
   "&inputType=" +escape(inputType) +
   "&phoneticInput=" +escape(phoneticInput) +
   "&serverOptions=" +escape(serverOptions) +
   "&viewAs=" + escape(viewAs);
   if(transflag){
        ans = ans+"&doTrans=f";
    }
    //alert(ans);
//if(url == "getHier"){
//requests[1].open("GET", ans, true);
  //requests[1].onreadystatechange = updateDisp2;
  //requests[1].send(null);
  //requestsActive[1]=true;
//document.getElementById("displist").innerHTML = 'working too ';
//}
//else{
  //  requests[0].open("GET", ans, true);
  //requests[0].onreadystatechange = updateDisp;
  //requests[0].send(null);
  //requestsActive[0]=true;
//document.getElementById("disp").innerHTML = 'working too ';
//}
return ans;
}

function updateDisp() {
  if (requests[0].readyState == 4) {
     // alert("reached in 1");
   requestsActive[0]=false;
   if (requests[0].status == 200) {
       
    var response = requests[0].responseText;
    var ansEl = document.getElementById("disp");
//    alert('data ready for display...' + response);
    ansEl.innerHTML = response;
     
     // kick off the next ajax request
 //debug      if(getlistFlag){getWordlist_keyboard();}    
//    return;
  } else {
    //alert("Error! Request status for 00 is " + requests[0].status);
  }
 }
}

function updateDisplist() {
  if (requests[1].readyState == 4) {
      //alert("reached in 3");
   requestsActive[1]=false;
   if (requests[1].status == 200) {
    var response = requests[1].responseText;
    var ansEl = document.getElementById("displist");
//    alert('data ready for display...' + response);
    ansEl.innerHTML = response;
//    return;
  } else {
    //alert("Error! Request status for  11 is " + requests[1].status);
  }
 }
}
function winls(url,anchor) {
// Called by a link made by monierdisp.php
 var url1 = 'Lexicons/MW/mwauth/'+url+'#'+anchor;
 win_ls = window.open(url1,
    "winls", "width=520,height=210,scrollbars=yes");
 win_ls.focus();
}